function GetPageFN(iPage) {
  if (iPage == 1) {
    return "index.htm";
  }

  return "page" + IntToStr(iPage, 5) + ".htm";
}

function GetImgPageFN(iFile) {
  return "ipage" + IntToStr(iFile, 5) + ".htm";
}

function GetPagesNavigation(iPagesCount, iCurPage) {
  cNavigation = "";
  for (iPage=1; iPage <= iPagesCount; iPage++) {
    if (iPage == iCurPage) {
      cNavigation += "<b>"+IntToStr(iPage, 0)+"</b>\n";
    } else {
      cNavigation += "<a href=\""+GetPageFN(iPage)+"\">"+IntToStr(iPage, 0)+"</a>\n";
    }
  }
  return cNavigation;
}

function GetImgPagesNavigation(iFilesCount, iCurFile) {
  cNavigation = "";
  for (iFile=1; iFile <= iFilesCount; iFile++) {
    if (iFile == iCurFile) {
      cNavigation += "<b>"+IntToStr(iFile, 0)+"</b>\n";
    } else {
      cNavigation += "<a href=\""+GetImgPageFN(iFile)+"\">"+IntToStr(iFile, 0)+"</a>\n";
    }
  }
  return cNavigation;
}

function GenerateAlbum(cSourcePath, cDestPath)
{
  if (bGlobalTitle)
  {
    cTitle	= cGlobalTitle;
    cHeader	= cGlobalTitle;
    cImgHeader  = cGlobalTitle;
    cImgTitle	= cGlobalTitle;
  }
  var iFilesCount = lSelectedFiles.GetCount();
  var iDirsCount = lSelectedDirs.GetCount();
  
  InitProgress(iDirsCount + iFilesCount);

  var iPagesCount = Math.ceil(iFilesCount / (iCols*iRows));

  var iNavStyle = parseInt(cNavStyle);
  var iImgNavStyle = parseInt(cImgNavStyle);

  var tPage = new CTemplate();
  tPage.Load(cSourcePath + "page.tpl", 0);
  tPage.SetReplace("${CSS_FILENAME}", "page.css");

  tPage.SetReplace("${TITLE}", ReplaceExifStrings(cTitle, "", ""));
  tPage.SetReplace("${HEADER}", ReplaceExifStrings(cHeader, "", ""));
  tPage.SetReplace("${FOOTER}", ReplaceExifStrings(cFooter, "", ""));

  var tPageCSS = new CTemplate();
  tPageCSS.Load(cSourcePath + "css.tpl", 0);

  var iDescTDWidth = iThnWidth+4;
  var iThnTDWidth = iThnWidth+12;
  var iThnTDHeight = iThnHeight+12;
  var iOrgTDWidth = iThnWidth+4;

  var iThnTableWidth = (iCols)*(iThnTDWidth) + (iCols+1)*(1); // (1) ... cellspacing="1"

  if (bBackImage)
    tPageCSS.SetReplace("${BACKGROUND}", HEXColor(iBgColor) + " url(" + cBackImageURL + ")");
  else
    tPageCSS.SetReplace("${BACKGROUND}", HEXColor(iBgColor));

  tPageCSS.SetReplace("${HEAD_FONT_SIZE}", iHeaderFontSize);
  tPageCSS.SetReplace("${HEAD_FONT_COLOR}", HEXColor(iHeaderFontColor));
  tPageCSS.SetReplace("${THN_TABLE_WIDTH}", iThnTableWidth);
  tPageCSS.SetReplace("${DESC_FONT_SIZE}", iDescFontSize);
  tPageCSS.SetReplace("${INDEX_DESC_TITLE_FONT_SIZE}", iDescFontSize*1.2);
  tPageCSS.SetReplace("${DESC_FONT_COLOR}", HEXColor(iDescFontColor));
  tPageCSS.SetReplace("${DESC_BGCOLOR}", HEXColor(iDescBgColor));
  tPageCSS.SetReplace("${DESC_LINK_COLOR}", HEXColor(iDescLinkColor));
  tPageCSS.SetReplace("${DESC_TD_WIDTH}", iDescTDWidth);
  tPageCSS.SetReplace("${THN_TD_WIDTH}", iThnTDWidth);
  tPageCSS.SetReplace("${THN_TD_HEIGHT}", iThnTDHeight);
  tPageCSS.SetReplace("${ORG_TD_WIDTH}", iOrgTDWidth);
  tPageCSS.SetReplace("${THN_BGCOLOR}", HEXColor(iThnBgColor));
  tPageCSS.SetReplace("${ORG_FONT_SIZE}", iOrgFontSize);
  tPageCSS.SetReplace("${ORG_FONT_COLOR}", HEXColor(iOrgFontColor));
  tPageCSS.SetReplace("${ORG_BGCOLOR}", HEXColor(iOrgBgColor));
  tPageCSS.SetReplace("${ORG_LINK_COLOR}", HEXColor(iOrgLinkColor));
  tPageCSS.SetReplace("${FOOT_FONT_SIZE}", iFooterFontSize);
  tPageCSS.SetReplace("${FOOT_FONT_COLOR}", HEXColor(iFooterFontColor));
  tPageCSS.SetReplace("${NAV_FONT_SIZE}", iNavFontSize);
  tPageCSS.SetReplace("${NAV_FONT_COLOR}", HEXColor(iNavFontColor));
  tPageCSS.SetReplace("${NAV_BGCOLOR}", HEXColor(iNavBgColor));
  tPageCSS.SetReplace("${NAV_TEXT_BGCOLOR}", HEXColor(iNavTextBgColor));
  tPageCSS.SetReplace("${NAV_LINK_COLOR}", HEXColor(iNavLinkColor));

  SaveString(cDestPath + "page.css", tPageCSS.Replace(), 0);



  var tImg = new CTemplate();
  tImg.Load(cSourcePath + "page.tpl", 0);
  tImg.SetReplace("${CSS_FILENAME}", "img.css");

  tImg.SetReplace("${TITLE}", cImgTitle);
  tImg.SetReplace("${INDEXES}", "");

  var tImgCSS = new CTemplate();
  tImgCSS.Load(cSourcePath + "css.tpl", 0);

  var iImgDescTDWidth = iImgWidth+4;
  var iImgTDWidth = iImgWidth+12;
  var iImgTDHeight = iImgHeight+12;
  var iImgOrgTDWidth = iImgWidth+4;

  var iImgTableWidth = iImgTDWidth + 2; // 2 ... 2 x cellspacing="1"

  if (bBackImage)
    tImgCSS.SetReplace("${BACKGROUND}", HEXColor(iImgBgColor) + " url(" + cBackImageURL + ")");
  else
    tImgCSS.SetReplace("${BACKGROUND}", HEXColor(iImgBgColor));

  tImgCSS.SetReplace("${HEAD_FONT_SIZE}", iImgHeaderFontSize);
  tImgCSS.SetReplace("${HEAD_FONT_COLOR}", HEXColor(iImgHeaderFontColor));
  tImgCSS.SetReplace("${THN_TABLE_WIDTH}", iImgTableWidth);
  tImgCSS.SetReplace("${DESC_FONT_SIZE}", iImgDescFontSize);
  tImgCSS.SetReplace("${INDEX_DESC_TITLE_FONT_SIZE}", iImgDescFontSize*1.2);
  tImgCSS.SetReplace("${DESC_FONT_COLOR}", HEXColor(iImgDescFontColor));
  tImgCSS.SetReplace("${DESC_BGCOLOR}", HEXColor(iImgDescBgColor));
  tImgCSS.SetReplace("${DESC_LINK_COLOR}", HEXColor(iImgDescLinkColor));
  tImgCSS.SetReplace("${DESC_TD_WIDTH}", iImgDescTDWidth);
  tImgCSS.SetReplace("${THN_TD_WIDTH}", iImgTDWidth);
  tImgCSS.SetReplace("${THN_TD_HEIGHT}", iImgTDHeight);
  tImgCSS.SetReplace("${ORG_TD_WIDTH}", iImgOrgTDWidth);
  tImgCSS.SetReplace("${THN_BGCOLOR}", HEXColor(iImgImgBgColor));
  tImgCSS.SetReplace("${ORG_FONT_SIZE}", iImgOrgFontSize);
  tImgCSS.SetReplace("${ORG_FONT_COLOR}", HEXColor(iImgOrgFontColor));
  tImgCSS.SetReplace("${ORG_BGCOLOR}", HEXColor(iImgOrgBgColor));
  tImgCSS.SetReplace("${ORG_LINK_COLOR}", HEXColor(iImgOrgLinkColor));
  tImgCSS.SetReplace("${FOOT_FONT_SIZE}", iImgFooterFontSize);
  tImgCSS.SetReplace("${FOOT_FONT_COLOR}", HEXColor(iImgFooterFontColor));
  tImgCSS.SetReplace("${NAV_FONT_SIZE}", iImgNavFontSize);
  tImgCSS.SetReplace("${NAV_FONT_COLOR}", HEXColor(iImgNavFontColor));
  tImgCSS.SetReplace("${NAV_BGCOLOR}", HEXColor(iImgNavBgColor));
  tImgCSS.SetReplace("${NAV_TEXT_BGCOLOR}", HEXColor(iImgNavTextBgColor));
  tImgCSS.SetReplace("${NAV_LINK_COLOR}", HEXColor(iImgNavLinkColor));

  SaveString(cDestPath + "img.css", tImgCSS.Replace(), 0);

  var tNav = new CTemplate();
  if (iNavStyle == 1) {
    tNav.Load(cSourcePath + "nav_1.tpl", 0);
  }
  if (iNavStyle == 2) {
    tNav.Load(cSourcePath + "nav_2.tpl", 0);
  }

  var tImgNav = new CTemplate();
  if (iImgNavStyle == 1) {
    tImgNav.Load(cSourcePath + "img_nav_1.tpl", 0);
  }
  if (iImgNavStyle == 2) {
    tImgNav.Load(cSourcePath + "img_nav_2.tpl", 0);
  }

  var tDirNav = new CTemplate();
  tDirNav.Load(cSourcePath + "dir_nav.tpl", 0);

  var tRow = new CTemplate();
  if (bOriginal)
  	 tRow.Load(cSourcePath + "row.tpl", 0);
  else
  	 tRow.Load(cSourcePath + "noorig_row.tpl", 0);

  var tImgRow = new CTemplate();
  if (bImgOriginal)
  	 tImgRow.Load(cSourcePath + "row.tpl", 0);
  else
  	 tImgRow.Load(cSourcePath + "noorig_row.tpl", 0);

  var tDescCol = new CTemplate();
  tDescCol.Load(cSourcePath + "desc_col.tpl", 0);

  var tImgDescCol = new CTemplate();
  tImgDescCol.Load(cSourcePath + "desc_col.tpl", 0);

  var tThnCol = new CTemplate();
  tThnCol.Load(cSourcePath + "img_col.tpl", 0);

  var tImgCol = new CTemplate();
  tImgCol.Load(cSourcePath + "img_col.tpl", 0);

  var tOrgCol = new CTemplate();
  tOrgCol.Load(cSourcePath + "org_col.tpl", 0);

  var tImgOrgCol = new CTemplate();
  tImgOrgCol.Load(cSourcePath + "org_col.tpl", 0);

  var pMagImg0 = new CImage();
  pMagImg0.Load(cSourcePath + "magnify-.png", 0);

  var pMagImg1 = new CImage();
  pMagImg1.Load(cSourcePath + "magnify+.png", 0);
  
  var cRelativePath = pAlbum.cCurrentGalleryRelativePath;
  var cRelativeReturnPath = GetReturnPathFromRelativePath(cRelativePath);
  var cRelativePathH = StrReplace(cRelativePath, "\\", "/");
  var cRelativeReturnPathH = StrReplace(cRelativeReturnPath, "\\", "/");

  var cRows = "";
  var cDescCols = "";
  var cImgCols = "";
  var cOrgCols = "";

  var iCol = 0;
  var iRow = 0;
  var iPage = 1;

  var iImgFrom = 1;
  var iImgTo = 1;

  if (pAlbum.bIsCurrentGalleryRootGallery)
  {
    tDirNav.SetReplace("${NAV_ROOT}", "*");
    tDirNav.SetReplace("${NAV_UP}", "^");
    tNav.SetReplace("${NAV_ROOT}", "*");
    tNav.SetReplace("${NAV_UP}", "^");
    tImgNav.SetReplace("${NAV_ROOT}", "*");
  }
  else
  {
    tDirNav.SetReplace("${NAV_ROOT}", "<a href=\""+cRelativeReturnPathH+GetPageFN(1)+"\">*</a>");
    tDirNav.SetReplace("${NAV_UP}", "<a href=\""+"../"+GetPageFN(1)+"\">^</a>");
    tNav.SetReplace("${NAV_ROOT}", "<a href=\""+cRelativeReturnPathH+GetPageFN(1)+"\">*</a>");
    tNav.SetReplace("${NAV_UP}", "<a href=\""+"../"+GetPageFN(1)+"\">^</a>");
    tImgNav.SetReplace("${NAV_ROOT}", "<a href=\""+cRelativeReturnPathH+GetPageFN(1)+"\">*</a>");
  }

  var cDirNav = tDirNav.Replace();
  tPage.SetReplace("${INDEXES}", "");
  tPage.SetReplace("${NAV1}", cDirNav);
  tPage.SetReplace("${NAV2}", "");
  tPage.SetReplace("${NAV3}", "");
  tPage.SetReplace("${ROWS}", "<br>");
  SaveString(cDestPath + GetPageFN(1), tPage.Replace(), 0);

  if (iDirsCount > 0)
  {
    var pDefFolderImage = new CImage();
    pDefFolderImage.Load(cSourcePath + "folder.png", 0);
    
    var iIndexDescTdWidth = (iCols-1)*(iThnTDWidth) + (iCols-1+1)*(1); // (1) ... cellspacing="1"
    tPageCSS.SetReplace("${INDEX_DESC_TD_WIDTH}", iIndexDescTdWidth);

    var tIndexes = new CTemplate();
    tIndexes.Load(cSourcePath + "indexes.tpl", 0);
    
    var tIndexRow = new CTemplate();
    tIndexRow.Load(cSourcePath + "index_row.tpl", 0);
    
    var cIndexRows = "";
    
    var cDirs = "";

    for (var iDir = 1; iDir <= iDirsCount; iDir++)
    {
      SetProgress(iDir);
    
      cDirName = lSelectedDirs.GetAt(iDir-1);
      
      cRelDirName = StripFilePath(cDirName);
      
      CreateDir(cDestPath + cRelDirName);

      var pFolderImage = new CImage();
      var bCustomFolderImage = pFolderImage.LoadDirPreview(cDirName, pDefFolderImage);
      pFolderImage.Render(iThnBgColor);

      pFolderImage.Resize(iThnWidth, iThnHeight, GFX_KEEP_ASPECT | GFX_INTERPOLATE);
      pFolderImage.SaveAs(cDestPath + cRelDirName + "\\" + "folder.png", PNGformat, 0, 0);

      tIndexRow.SetReplace("${URL}", cRelDirName + "/index.htm");
      tIndexRow.SetReplace("${IMG_FILENAME}", cRelDirName + "/" + "folder.png");
      tIndexRow.SetReplace("${IMG_WIDTH}", pFolderImage.GetWidth());
      tIndexRow.SetReplace("${IMG_HEIGHT}", pFolderImage.GetHeight());
      tIndexRow.SetReplace("${INDEX_TITLE}", ReplaceExifStrings("{T}", cDirName, cDirName));
      tIndexRow.SetReplace("${INDEX_DESC}", ReplaceExifStrings("{D}", cDirName, cDirName));
      
      pFolderImage.Close();
      
      cIndexRows += tIndexRow.Replace();
    }
    
    pDefFolderImage.Close();
    tIndexes.SetReplace("${INDEX_ROWS}", cIndexRows);
    tPage.SetReplace("${INDEXES}", tIndexes.Replace());
  }

//  for (var iFile = 1; ((iFile <= iFilesCount) || (iCol != 0) || (iRow != 0)); iFile++) {
  for (var iFile = 1; ((iFile <= iFilesCount) || (iCol != 0)); iFile++) {
    if (iFile <= iFilesCount) {

      SetProgress(iDirsCount + iFile);
// FILE 
      iImgTo = iFile;

      cFileName = lSelectedFiles.GetAt(iFile-1);
      if (bUseOriginalFileNames)
      {
        cGetFileName = GetFileName(cFileName);

        cThnFileName = "thn_" + cGetFileName + ".jpg";
        cImgFileName = cGetFileName + ".jpg";
        cOrgFileName = cGetFileName + "." + GetFileExt(cFileName);

        if (bOriginal || bImgOriginal)
        {
          cImgFileName = "img_" + cImgFileName;
        }
      }
      else
      {
        cNumFileName = IntToStr(iFile, 5);
        cThnFileName = "thn" + cNumFileName + ".jpg";
        cImgFileName = "img" + cNumFileName + ".jpg";
        cOrgFileName = "org" + cNumFileName + "." + GetFileExt(cFileName).toLowerCase();
      }

// LOAD FILE
      var pImg = new CImage();
      pImg.Load(cFileName, 0);

// MAKE IMAGE
      pImg.Resize(iImgWidth, iImgHeight, GFX_KEEP_ASPECT | GFX_INTERPOLATE);
      var rcMag = pMagImg0.GetRect();
      if (bImgMag) {
        pMagImg0.Draw(pImg, rcMag, pImg.GetWidth()-rcMag.Width()-1, pImg.GetHeight()-rcMag.Height()-1, 192, GFX_KEEP_ALPHA);
      }
      pImg.SaveAs(cDestPath + cImgFileName, JPGformat, iImgJPEG, 0);

// IMAGE HEADER
      tImg.SetReplace("${TITLE}", ReplaceExifStrings(cImgTitle, cFileName, cDestPath + cImgFileName)); 
      tImg.SetReplace("${HEADER}", ReplaceExifStrings(cImgHeader, cFileName, cDestPath + cImgFileName)); 

// IMAGE NAVIGATION
      if (iFile > 1) {
        tImgNav.SetReplace("${NAV_FIRST}", "<a href=\""+GetImgPageFN(1)+"\">|&lt;</a>");
        tImgNav.SetReplace("${NAV_PREV}", "<a href=\""+GetImgPageFN(iFile-1)+"\">&lt;&lt;</a>");
      } else {
        tImgNav.SetReplace("${NAV_FIRST}", "|&lt;");
        tImgNav.SetReplace("${NAV_PREV}", "&lt;&lt;");
      }
      if (iFile < iFilesCount) {
        tImgNav.SetReplace("${NAV_NEXT}", "<a href=\""+GetImgPageFN(iFile+1)+"\">&gt;&gt;</a>");
        tImgNav.SetReplace("${NAV_LAST}", "<a href=\""+GetImgPageFN(iFilesCount)+"\">&gt;|</a>");
      } else {
        tImgNav.SetReplace("${NAV_NEXT}", "&gt;&gt;");
        tImgNav.SetReplace("${NAV_LAST}", "&gt;|");
      }
      if (iImgNavStyle == 1) {
        tImgNav.SetReplace("${NAV_IMG}", iFile);
        tImgNav.SetReplace("${NAV_IMGS}", iFilesCount);
      } else {
        tImgNav.SetReplace("${NAV_NAV}", GetImgPagesNavigation(iFilesCount, iFile));
      }
      tImgNav.SetReplace("${NAV_UP}", "<a href=\""+GetPageFN(iPage)+"\">^</a>");
      tImg.SetReplace("${NAV1}", "");
      tImg.SetReplace("${NAV2}", tImgNav.Replace());
      tImg.SetReplace("${NAV3}", tImgNav.Replace());

// IMAGE TABLE
      tImgDescCol.SetReplace("${IMG_DESC}", ReplaceExifStrings(cImgDesc, cFileName, cDestPath + cImgFileName));
      tImgRow.SetReplace("${DESC_COLS}", tImgDescCol.Replace());

      tImgCol.SetReplace("${IMG_PAGE_FILENAME}", GetPageFN(iPage));
      tImgCol.SetReplace("${IMG_FILENAME}", cImgFileName); 
      tImgCol.SetReplace("${IMG_WIDTH}", pImg.GetWidth()); 
      tImgCol.SetReplace("${IMG_HEIGHT}", pImg.GetHeight()); 
      tImgRow.SetReplace("${IMG_COLS}", tImgCol.Replace());

      if (bImgOriginal) {
        tImgOrgCol.SetReplace("${ORG_FILENAME}", cOrgFileName);
        tImgOrgCol.SetReplace("${ORG_DESC}", ReplaceExifStrings(cImgOrgDesc, cFileName, "")); 
        CopyFile(cFileName, cDestPath + cOrgFileName, FIL_OM_OVERWRITE);
        tImgRow.SetReplace("${ORG_COLS}", tImgOrgCol.Replace());
      }
      
      tImg.SetReplace("${ROWS}", tImgRow.Replace());

// IMAGE FOOTER
      tImg.SetReplace("${FOOTER}", ReplaceExifStrings(cImgFooter, cFileName, cDestPath + cImgFileName)); 

// IMAGE SAVE
      SaveString(cDestPath + GetImgPageFN(iFile), tImg.Replace(), 0);


// MAKE THUMB
      pImg.Resize(iThnWidth, iThnHeight, GFX_KEEP_ASPECT | GFX_INTERPOLATE);
//BOOL CJSImage::Draw(CJSImage* pDstImage, CJSRect* pSrcRect, int iPosX, int iPosY, int iAlpha, int iFlags)
      var rcMag = pMagImg1.GetRect();
      if (bThnMag) {
        pMagImg1.Draw(pImg, rcMag, pImg.GetWidth()-rcMag.Width()-1, pImg.GetHeight()-rcMag.Height()-1, 192, GFX_KEEP_ALPHA);
      }
      pImg.SaveAs(cDestPath + cThnFileName, JPGformat, iTNJPEG, 0);

// THUMB TABLE
      tDescCol.SetReplace("${IMG_DESC}", ReplaceExifStrings(cDesc, cFileName, cDestPath + cImgFileName)); 
      cDescCols += tDescCol.Replace();

      tThnCol.SetReplace("${IMG_PAGE_FILENAME}", GetImgPageFN(iFile));
      tThnCol.SetReplace("${IMG_FILENAME}", cThnFileName);
      tThnCol.SetReplace("${IMG_WIDTH}", pImg.GetWidth());
      tThnCol.SetReplace("${IMG_HEIGHT}", pImg.GetHeight());
      cImgCols += tThnCol.Replace();


      if (bOriginal)
	  {
        tOrgCol.SetReplace("${ORG_FILENAME}", cOrgFileName);
        tOrgCol.SetReplace("${ORG_DESC}", ReplaceExifStrings(cOrgDesc, cFileName, cFileName)); 
        if (!bImgOriginal) { // if not copied in IMAGE processing
          CopyFile(cFileName, cDestPath + cOrgFileName, FIL_OM_OVERWRITE);
        }
        cOrgCols += tOrgCol.Replace();
      }

      pImg.Close();

    } else { // no other files to process, make table complete
      cDescCols += "  <td class=\"img_desc_td_empty\"></td>\r\n";
      cImgCols += "  <td class=\"img_td_empty\"></td>\r\n";
      cOrgCols += "  <td class=\"img_org_td_empty\"></td>\r\n";
    }

    iCol++;

    if (iCol >= iCols) {
      tRow.SetReplace("${DESC_COLS}", cDescCols);
      tRow.SetReplace("${IMG_COLS}", cImgCols);
      tRow.SetReplace("${ORG_COLS}", cOrgCols);
      cRows += tRow.Replace();

      cDescCols = "";
      cImgCols = "";
      cOrgCols = "";
      iCol = 0;

      iRow++;
    }

    if ((iRow >= iRows) || ((iFile >= iFilesCount) && (iCol == 0))) {

      if (iPage > 1) {
        tNav.SetReplace("${NAV_FIRST}", "<a href=\""+GetPageFN(1)+"\">|&lt;</a>");
        tNav.SetReplace("${NAV_PREV}", "<a href=\""+GetPageFN(iPage-1)+"\">&lt;&lt;</a>");
      } else {
        tNav.SetReplace("${NAV_FIRST}", "|&lt;");
        tNav.SetReplace("${NAV_PREV}", "&lt;&lt;");
      }
      if (iPage < iPagesCount) {
        tNav.SetReplace("${NAV_NEXT}", "<a href=\""+GetPageFN(iPage+1)+"\">&gt;&gt;</a>");
        tNav.SetReplace("${NAV_LAST}", "<a href=\""+GetPageFN(iPagesCount)+"\">&gt;|</a>");
      } else {
        tNav.SetReplace("${NAV_NEXT}", "&gt;&gt;");
        tNav.SetReplace("${NAV_LAST}", "&gt;|");
      }
      if (iNavStyle == 1) {
        tNav.SetReplace("${NAV_PAGE}", iPage);
        tNav.SetReplace("${NAV_PAGES}", iPagesCount);
        tNav.SetReplace("${NAV_IMGFROM}", iImgFrom);
        tNav.SetReplace("${NAV_IMGTO}", iImgTo);
        tNav.SetReplace("${NAV_IMGS}", iFilesCount);
      } else {
        tNav.SetReplace("${NAV_NAV}", GetPagesNavigation(iPagesCount, iPage));
      }
      
      var cNav = tNav.Replace();
      if (iDirsCount == 0)
      	 tPage.SetReplace("${NAV1}", "");
  	  tPage.SetReplace("${NAV2}", cNav);
      tPage.SetReplace("${NAV3}", cNav);
      
      tPage.SetReplace("${ROWS}", cRows);

      SaveString(cDestPath + GetPageFN(iPage), tPage.Replace(), 0);
      
      cRows = "";
      iRow = 0;

      iImgFrom = iFile + 1;

      iPage++;
    }

  }
  
  if (iDirsCount > 0 && iFilesCount == 0)
  {
      tPage.SetReplace("${NAV2}", cDirNav);
      tPage.SetReplace("${NAV3}", "");
      tPage.SetReplace("${ROWS}", "");
      SaveString(cDestPath + GetPageFN(1), tPage.Replace(), 0);
  }

  return cDestPath + GetPageFN(1);
  
}

INIT_OK;
